#!/bin/bash
# Copyright (c) 2008 by S.Chekanov (chakanau@hep.anl.gov). 
# All rights reserved.


"exec" "python" "-Wignore" "$0" "$@"

__version__ = '1.5'
__author__  = 'Sergei Chekanov  (chakanau@hep.anl.gov)'
__doc__     = 'MIrror Hepsim'

import sys, getopt
import os,sys,urllib,urllib2 
import zipfile

def  getFilesFromZip(name):
    zf = zipfile.ZipFile(name, 'r')
    # print zf.namelist()
    filename="files"
    data=[]
    try:
       lines = zf.open(filename).readlines()
       for line in lines:
           if line.find("#")>-1: continue
           line=line.strip();
           line=line.replace("/n","")
           lines=line.split();
           data.append(lines[1].replace("/n",""))
    except KeyError:
       print 'ERROR: Did not find %s in zip file' % filename
    return data

def  getFiles(name):
    data=[]
    lines = open(name).readlines()
    for line in lines:
           if line.find("#")>-1: continue
           line=line.strip();
           line=line.replace("/n","")
           data.append(line)
    return data



def main(argv):
   inputfile = ''
   outputfile = ''
   try:
      opts, args = getopt.getopt(argv,"hi:o:",["ifile=","ofile="])
   except getopt.GetoptError:
      print 'mirror_hepsim_data.py -i <input url> -o <output dir>'
      sys.exit(2)
   for opt, arg in opts:
      if opt == '-h':
         print 'mirror_hepsim_data.py -i <input url> -o <output dir>'
         sys.exit()
      elif opt in ("-i", "--ifile"):
         inputfile = arg
      elif opt in ("-o", "--ofile"):
         outputfile = arg
   SOURCE_PAGE=inputfile
   OUTPUT_DIR=outputfile
   xdir=SOURCE_PAGE.split("/events/")
   XDIR=OUTPUT_DIR+"/events/"+xdir[1]
   print  "Source=",SOURCE_PAGE
   print  "Mirror=",XDIR
   cmt="mkdir -p "+XDIR
   os.system(cmt)
   print cmt

   print "Get EVGEN root directory"
   urllib.urlretrieve(SOURCE_PAGE+"/dirs.idx", XDIR+"/dirs.idx")
   urllib.urlretrieve(SOURCE_PAGE+"/metadata.txt", XDIR+"/metadata.txt")
   urllib.urlretrieve(SOURCE_PAGE+"/files.zip", XDIR+"/files.zip")

   data = getFilesFromZip(XDIR+"/files.zip")
   totfiles=len(data);nn=1
   for j in data:
     print "-> get ",j, "Progress=",nn,"/",totfiles
     urllib.urlretrieve(SOURCE_PAGE+"/"+j, XDIR+"/"+j)
     nn=nn+1

   dirs=getFiles(XDIR+"/dirs.idx")
   for m in dirs:
      XDIR1= XDIR+"/"+m
      cmt="mkdir -p "+XDIR1
      os.system(cmt)
      print "Prepare ",XDIR1
      urllib.urlretrieve(SOURCE_PAGE+"/"+m+"/dirs.idx", XDIR1+"/dirs.idx")
      urllib.urlretrieve(SOURCE_PAGE+"/"+m+"/files.zip", XDIR1+"/files.zip")
      data = getFilesFromZip(XDIR1+"/files.zip")
      totfiles=len(data);nn=1
      for j in data:
          print "  -> get ",j, "Progress=",nn,"/",totfiles
          urllib.urlretrieve(SOURCE_PAGE+"/"+m+"/"+j, XDIR1+"/"+j)
          nn=nn+1
   print "Dataset was mirrored in "+XDIR







if __name__ == "__main__":
   if (len(sys.argv)) <2:
     print "No arguments. Please use \"mirror_hepsim_data.py -h\" for help" 
   else:
     main(sys.argv[1:])


